source: installer/opengnsys_installer.sh @ fc9a1ad

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since fc9a1ad was 1635f45, checked in by ramon <ramongomez@…>, 7 years ago

#804: Dejar de instalar antigua librería xajax incompatible con PHP 7.

git-svn-id: https://opengnsys.es/svn/branches/version1.1@5626 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 58.1 KB
RevLine 
[a01156a]1#!/bin/bash
2
3#####################################################################
[5f21d34]4####### Script instalador OpenGnsys
5####### Autor: Luis Guillén <lguillen@unizar.es>
[a01156a]6#####################################################################
7
8
[9672640]9####  AVISO: Puede editar configuración de acceso por defecto.
10####  WARNING: Edit default access configuration if you wish.
11DEFAULT_MYSQL_ROOT_PASSWORD="passwordroot"      # Clave por defecto root de MySQL
[5f21d34]12DEFAULT_OPENGNSYS_DB_USER="usuog"               # Usuario por defecto de acceso a la base de datos
[9672640]13DEFAULT_OPENGNSYS_DB_PASSWD="passusuog"         # Clave por defecto de acceso a la base de datos
14DEFAULT_OPENGNSYS_CLIENT_PASSWD="og"            # Clave por defecto de acceso del cliente       
[4a3cd1f]15
[1e7eaab]16# Sólo ejecutable por usuario root
[6ef01d9]17if [ "$(whoami)" != 'root' ]; then
[1e7eaab]18        echo "ERROR: this program must run under root privileges!!"
19        exit 1
20fi
[9672640]21
[5f21d34]22echo -e "\\nOpenGnsys Installation"
[9672640]23echo "=============================="
24
25# Clave root de MySQL
26while : ; do
27        echo -n -e "\\nEnter root password for MySQL (${DEFAULT_MYSQL_ROOT_PASSWORD}): ";
[6019b12]28        read -r MYSQL_ROOT_PASSWORD
[9672640]29        if [ -n "${MYSQL_ROOT_PASSWORD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
30                echo -e "\\aERROR: Must be alphanumeric, try again..."
31        else
[6019b12]32                # Si esta vacio ponemos el valor por defecto
33                MYSQL_ROOT_PASSWORD="${MYSQL_ROOT_PASSWORD:-$DEFAULT_MYSQL_ROOT_PASSWORD}"
[9672640]34                break
35        fi
36done
37
38# Usuario de acceso a la base de datos
39while : ; do
[5f21d34]40        echo -n -e "\\nEnter username for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_USER}): "
[6019b12]41        read -r OPENGNSYS_DB_USER
[9672640]42        if [ -n "${OPENGNSYS_DB_USER//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
43                echo -e "\\aERROR: Must be alphanumeric, try again..."
44        else
[6019b12]45                # Si esta vacio ponemos el valor por defecto
46                OPENGNSYS_DB_USER="${OPENGNSYS_DB_USER:-$DEFAULT_OPENGNSYS_DB_USER}"
[9672640]47                break
48        fi
49done
50
51# Clave de acceso a la base de datos
52while : ; do
[5f21d34]53        echo -n -e "\\nEnter password for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_PASSWD}): "
[6019b12]54        read -r OPENGNSYS_DB_PASSWD
[9672640]55        if [ -n "${OPENGNSYS_DB_PASSWD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
56                echo -e "\\aERROR: Must be alphanumeric, try again..."
57        else
[6019b12]58                # Si esta vacio ponemos el valor por defecto
59                OPENGNSYS_DB_PASSWD="${OPENGNSYS_DB_PASSWD:-$DEFAULT_OPENGNSYS_DB_PASSWD}"
[9672640]60                break
61        fi
62done
63
64# Clave de acceso del cliente
65while : ; do
[5f21d34]66        echo -n -e "\\nEnter root password for OpenGnsys client (${DEFAULT_OPENGNSYS_CLIENT_PASSWD}): "
[6019b12]67        read -r OPENGNSYS_CLIENT_PASSWD
[9672640]68        if [ -n "${OPENGNSYS_CLIENT_PASSWD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
69                echo -e "\\aERROR: Must be alphanumeric, try again..."
70        else
[6019b12]71                # Si esta vacio ponemos el valor por defecto
72                OPENGNSYS_CLIENT_PASSWD="${OPENGNSYS_CLIENT_PASSWD:-$DEFAULT_OPENGNSYS_CLIENT_PASSWD}"
[9672640]73                break
74        fi
75done
76
[6019b12]77# Selección de clientes ogLive para descargar.
78while : ; do
79        echo -e "\\nChoose ogLive client to install."
80        echo -e "1) Kernel 4.8, 64-bit"
81        echo -e "2) Kernel 3.2, 32-bit"
82        echo -e "3) Both"
83        echo -n -e "Please, type a valid number (1): "
84        read -r OPT
85        case "$OPT" in
86                1|"")   OGLIVE="ogLive-xenial-4.8.0-39-generic-amd64-r5331.iso"
87                        break ;;
88                2)      OGLIVE="ogLive-precise-3.2.0-23-generic-r5159.iso"
89                        break ;;
90                3)      OGLIVE="ogLive-xenial-4.8.0-39-generic-amd64-r5331.iso ogLive-precise-3.2.0-23-generic-r5159.iso";
91                        break ;;
92                *)      echo -e "\\aERROR: unknown option, try again."
93        esac
94done
95
[9672640]96echo -e "\\n=============================="
[1e7eaab]97
98# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
[6019b12]99PROGRAMDIR=$(readlink -e "$(dirname "$0")")
[35b0ef1]100PROGRAMNAME=$(basename "$0")
[a0081b7]101OPENGNSYS_SERVER="opengnsys.es"
102DOWNLOADURL="https://$OPENGNSYS_SERVER/trac/downloads"
[1e7eaab]103if [ -d "$PROGRAMDIR/../installer" ]; then
[6ef01d9]104        USESVN=0
[1e7eaab]105else
[6ef01d9]106        USESVN=1
[1e7eaab]107fi
[a0081b7]108SVN_URL="https://$OPENGNSYS_SERVER/svn/branches/version1.1/"
[1e7eaab]109
[a01156a]110WORKDIR=/tmp/opengnsys_installer
[1e7eaab]111mkdir -p $WORKDIR
112
[5f21d34]113# Directorio destino de OpenGnsys.
[1e7eaab]114INSTALL_TARGET=/opt/opengnsys
[6019b12]115PATH=$PATH:$INSTALL_TARGET/bin
[42a0e41]116
117# Registro de incidencias.
118OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
[acfb07d]119LOG_FILE=/tmp/$(basename $OGLOGFILE)
[a01156a]120
[fd021b0]121# Usuario del cliente para acceso remoto.
122OPENGNSYS_CLIENT_USER="opengnsys"
123
124# Nombre de la base datos y fichero SQL para su creación.
125OPENGNSYS_DATABASE="ogAdmBD"
126OPENGNSYS_DB_CREATION_FILE=opengnsys/admin/Database/${OPENGNSYS_DATABASE}.sql
[3aaf91d]127
[a01156a]128
129#####################################################################
[d168a46]130####### Funciones de configuración
131#####################################################################
132
133# Generar variables de configuración del instalador
134# Variables globales:
[5cc52295]135# - OSDISTRIB, OSVERSION - tipo y versión de la distribución GNU/Linux
[d168a46]136# - DEPENDENCIES - array de dependencias que deben estar instaladas
137# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKGS - comandos para gestión de paquetes
[109e8b2]138# - INSTALLEXTRADEPS - instalar dependencias no incluidas en la distribución
[53fba30]139# - STARTSERVICE, ENABLESERVICE - iniciar y habilitar un servicio
[109e8b2]140# - STOPSERVICE, DISABLESERVICE - parar y deshabilitar un servicio
[53fba30]141# - APACHESERV, APACHECFGDIR, APACHESITESDIR, APACHEUSER, APACHEGROUP - servicio y configuración de Apache
[7825e9e]142# - APACHESSLMOD, APACHEENABLESSL, APACHEMAKECERT - habilitar módulo Apache y certificado SSL
[5f21d34]143# - APACHEENABLEOG, APACHEOGSITE, - habilitar sitio web de OpenGnsys
[53fba30]144# - INETDSERV - servicio Inetd
[09ac3b8]145# - FIREWALLSERV - servicio de cortabuegos IPTables/FirewallD
[53fba30]146# - DHCPSERV, DHCPCFGDIR - servicio y configuración de DHCP
[0f8100d]147# - MYSQLSERV, TMPMYCNF - servicio MySQL y fichero temporal con credenciales de acceso
148# - MARIADBSERV - servicio MariaDB (sustituto de MySQL en algunas distribuciones)
[e70925a]149# - RSYNCSERV, RSYNCCFGDIR - servicio y configuración de Rsync
[53fba30]150# - SAMBASERV, SAMBACFGDIR - servicio y configuración de Samba
[a16ce1b]151# - TFTPSERV, TFTPCFGDIR - servicio y configuración de TFTP/PXE
[d168a46]152function autoConfigure()
153{
[44f6582]154# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
155if [ -f /etc/os-release ]; then
156        source /etc/os-release
[eb7b39d]157        OSDISTRIB="$ID"
[5cc52295]158        OSVERSION="$VERSION_ID"
[44f6582]159else
160        OSDISTRIB=$(lsb_release -is 2>/dev/null)
[5cc52295]161        OSVERSION=$(lsb_release -rs 2>/dev/null)
[44f6582]162fi
[5cc52295]163# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
[eb7b39d]164OSDISTRIB="${OSDISTRIB,,}"
[5cc52295]165OSVERSION="${OSVERSION%%.*}"
[d168a46]166
[eb7b39d]167# Configuración según la distribución GNU/Linux (usar minúsculas).
[d168a46]168case "$OSDISTRIB" in
[eb7b39d]169        ubuntu|debian|linuxmint)
[3bf09ba]170                DEPENDENCIES=( subversion apache2 php5 php5-ldap libapache2-mod-php5 mysql-server php5-mysql isc-dhcp-server bittorrent tftp-hpa tftpd-hpa xinetd build-essential g++-multilib libmysqlclient15-dev wget curl doxygen graphviz bittornado ctorrent samba rsync unzip netpipes debootstrap schroot squashfs-tools btrfs-tools procps arp-scan realpath php5-curl gettext moreutils jq wakeonlan )
[d168a46]171                UPDATEPKGLIST="apt-get update"
172                INSTALLPKG="apt-get -y install --force-yes"
173                CHECKPKG="dpkg -s \$package 2>/dev/null | grep Status | grep -qw install"
[53fba30]174                if which service &>/dev/null; then
[7ba85a4]175                        STARTSERVICE="eval service \$service restart"
[109e8b2]176                        STOPSERVICE="eval service \$service stop"
[53fba30]177                else
[7ba85a4]178                        STARTSERVICE="eval /etc/init.d/\$service restart"
[109e8b2]179                        STOPSERVICE="eval /etc/init.d/\$service stop"
[53fba30]180                fi
[7ba85a4]181                ENABLESERVICE="eval update-rc.d \$service defaults"
[109e8b2]182                DISABLESERVICE="eval update-rc.d \$service disable"
[53fba30]183                APACHESERV=apache2
[d168a46]184                APACHECFGDIR=/etc/apache2
[643ca8c]185                APACHESITESDIR=sites-available
[53fba30]186                APACHEOGSITE=opengnsys
[d168a46]187                APACHEUSER="www-data"
188                APACHEGROUP="www-data"
[7ba85a4]189                APACHESSLMOD="a2enmod ssl"
[7829e4e]190                APACHEREWRITEMOD="a2enmod rewrite"
[7ba85a4]191                APACHEENABLESSL="a2ensite default-ssl"
[53fba30]192                APACHEENABLEOG="a2ensite $APACHEOGSITE"
[643ca8c]193                APACHEMAKECERT="make-ssl-cert generate-default-snakeoil --force-overwrite"
[53fba30]194                DHCPSERV=isc-dhcp-server
[83518d5]195                DHCPCFGDIR=/etc/dhcp
[f243a47]196                INETDSERV=xinetd
197                INETDCFGDIR=/etc/xinetd.d
[53fba30]198                MYSQLSERV=mysql
[0f8100d]199                MARIADBSERV=mariadb
[e70925a]200                RSYNCSERV=rsync
201                RSYNCCFGDIR=/etc
[53fba30]202                SAMBASERV=smbd
[d168a46]203                SAMBACFGDIR=/etc/samba
204                TFTPCFGDIR=/var/lib/tftpboot
205                ;;
[eb7b39d]206        fedora|centos)
[325aac9]207                DEPENDENCIES=( subversion httpd mod_ssl php php-ldap mysql-server mysql-devel mysql-devel.i686 php-mysql dhcp tftp-server tftp xinetd binutils gcc gcc-c++ glibc-devel glibc-devel.i686 glibc-static glibc-static.i686 libstdc++-devel.i686 make wget curl doxygen graphviz ctorrent samba samba-client rsync unzip debootstrap schroot squashfs-tools python-crypto arp-scan procps-ng gettext moreutils jq net-tools http://ftp.altlinux.org/pub/distributions/ALTLinux/5.1/branch/$(arch)/RPMS.classic/netpipes-4.2-alt1.$(arch).rpm )
208                INSTALLEXTRADEPS=( 'pushd /tmp; wget -t3 http://download.bittornado.com/download/BitTornado-0.3.18.tar.gz && tar xvzf BitTornado-0.3.18.tar.gz && cd BitTornado-CVS && python setup.py install && ln -fs btlaunchmany.py /usr/bin/btlaunchmany && ln -fs bttrack.py /usr/bin/bttrack; popd' )
209                INSTALLPKG="yum install -y libstdc++ libstdc++.i686"
[c79a2b3]210                CHECKPKG="rpm -q --quiet \$package"
[03cfd6e]211                SYSTEMD=$(which systemctl 2>/dev/null)
212                if [ -n "$SYSTEMD" ]; then
213                        STARTSERVICE="eval systemctl start \$service.service"
214                        STOPSERVICE="eval systemctl stop \$service.service"
215                        ENABLESERVICE="eval systemctl enable \$service.service"
216                        DISABLESERVICE="eval systemctl disable \$service.service"
217                else
218                        STARTSERVICE="eval service \$service start"
219                        STOPSERVICE="eval service \$service stop"
220                        ENABLESERVICE="eval chkconfig \$service on"
221                        DISABLESERVICE="eval chkconfig \$service off"
222                fi
[53fba30]223                APACHESERV=httpd
[d168a46]224                APACHECFGDIR=/etc/httpd/conf.d
[53fba30]225                APACHEOGSITE=opengnsys.conf
[d168a46]226                APACHEUSER="apache"
227                APACHEGROUP="apache"
[5f21d34]228                APACHEREWRITEMOD="sed -i '/rewrite/s/^#//' $APACHECFGDIR/../*.conf"
[53fba30]229                DHCPSERV=dhcpd
[d168a46]230                DHCPCFGDIR=/etc/dhcp
[09ac3b8]231                if firewall-cmd --state &>/dev/null; then
232                        FIREWALLSERV=firewalld
233                else
234                        FIREWALLSERV=iptables
235                fi
[53fba30]236                INETDSERV=xinetd
[f243a47]237                INETDCFGDIR=/etc/xinetd.d
[53fba30]238                MYSQLSERV=mysqld
[0f8100d]239                MARIADBSERV=mariadb
[e70925a]240                RSYNCSERV=rsync
241                RSYNCCFGDIR=/etc
[53fba30]242                SAMBASERV=smb
[d168a46]243                SAMBACFGDIR=/etc/samba
[53fba30]244                TFTPSERV=tftp
[d168a46]245                TFTPCFGDIR=/var/lib/tftpboot
246                ;;
247        "")     echo "ERROR: Unknown Linux distribution, please install \"lsb_release\" command."
248                exit 1 ;;
[5f21d34]249        *)      echo "ERROR: Distribution not supported by OpenGnsys."
[d168a46]250                exit 1 ;;
251esac
[09bf701]252
253# Fichero de credenciales de acceso a MySQL.
254TMPMYCNF=/tmp/.my.cnf.$$
[d168a46]255}
256
[09ac3b8]257
[ff6c349]258# Modificar variables de configuración tras instalar paquetes del sistema.
259function autoConfigurePost()
260{
[09ac3b8]261local f
262
[44f6582]263# Configuraciones específicas para Samba y TFTP en Debian 6.
264[ -z "$SYSTEMD" -a ! -e /etc/init.d/$SAMBASERV ] && SAMBASERV=samba
265[ ! -e $TFTPCFGDIR ] && TFTPCFGDIR=/srv/tftp
266
[09ac3b8]267# Configuraciones específicas para SELinux permisivo en distintas versiones.
[44f6582]268[ -f /selinux/enforce ] && echo 0 > /selinux/enforce
[e5f9c147]269for f in /etc/sysconfig/selinux /etc/selinux/config; do
[4fdf2b1]270        [ -f $f ] && perl -pi -e 's/SELINUX=enforcing/SELINUX=permissive/g' $f
[09ac3b8]271done
272selinuxenabled 2>/dev/null && setenforce 0 2>/dev/null
[ff6c349]273}
274
275
[83518d5]276# Cargar lista de paquetes del sistema y actualizar algunas variables de configuración
277# dependiendo de la versión instalada.
278function updatePackageList()
279{
[ad69c61]280local DHCPVERSION PHP5VERSION
[83518d5]281
282# Si es necesario, actualizar la lista de paquetes disponibles.
283[ -n "$UPDATEPKGLIST" ] && eval $UPDATEPKGLIST
284
285# Configuración personallizada de algunos paquetes.
286case "$OSDISTRIB" in
[eb7b39d]287        ubuntu|linuxmint)       # Postconfiguación personalizada para Ubuntu.
[83518d5]288                # Configuración para DHCP v3.
[e4b1572]289                DHCPVERSION=$(apt-cache show $(apt-cache pkgnames|egrep "dhcp.?-server$") | \
[83518d5]290                              awk '/Version/ {print substr($2,1,1);}' | \
291                              sort -n | tail -1)
292                if [ $DHCPVERSION = 3 ]; then
[e4b1572]293                        DEPENDENCIES=( ${DEPENDENCIES[@]/isc-dhcp-server/dhcp3-server} )
[53fba30]294                        DHCPSERV=dhcp3-server
[83518d5]295                        DHCPCFGDIR=/etc/dhcp3
296                fi
[ad69c61]297                # Configuración para PHP 5 en Ubuntu 16.x+.
298                if [ -z "$(apt-cache pkgnames php5)" ]; then
[668f7dc]299                        eval $INSTALLPKG software-properties-common
[21f78d1]300                        add-apt-repository -y ppa:ondrej/php
[668f7dc]301                        eval $UPDATEPKGLIST
[ad69c61]302                fi
[21f78d1]303                PHP5VERSION=$(apt-cache pkgnames php5 | sort | head -1)
304                DEPENDENCIES=( ${DEPENDENCIES[@]//php5/$PHP5VERSION} )
[ad69c61]305                # Dependencias correctas para libmysqlclient.
[21f78d1]306                [ -z "$(apt-cache pkgnames libmysqlclient15)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//libmysqlclient15/libmysqlclient} )
[83518d5]307                ;;
[eb7b39d]308        centos) # Postconfiguación personalizada para CentOS.
[e7d4fbb7]309                # Configuración para PHP 5.
[325aac9]310                if ! yum list php5\*w &>/dev/null; then
311                        if [ $OSVERSION -ge 7 ]; then
312                                yum install -y https://mirror.webtatic.com/yum/el$OSVERSION/webtatic-release.rpm
313                        else
314                                yum install -y https://mirror.webtatic.com/yum/el$OSVERSION/latest.rpm
315                        fi
316                        PHP5VERSION=$(yum list -q php5\*w | awk -F. '/^php/ {p=$1} END {print p}')
317                        DEPENDENCIES=( ${DEPENDENCIES[@]//php/$PHP5VERSION} )
318                fi
[2c8b9ed]319                # Cambios a aplicar a partir de CentOS 7.
320                if [ $OSVERSION -ge 7 ]; then
321                        # Sustituir MySQL por MariaDB.
322                        DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
[325aac9]323                        # Instalar ctorrent de EPEL para CentOS 6 (no disponible en CentOS 7).
324                        DEPENDENCIES=( ${DEPENDENCIES[*]/ctorrent/http://dl.fedoraproject.org/pub/epel/6/$(arch)/Packages/c/ctorrent-1.3.4-14.dnh3.3.2.el6.$(arch).rpm} )
[2c8b9ed]325                fi
[c525453]326                ;;
[eb7b39d]327        fedora) # Postconfiguación personalizada para Fedora.
[c525453]328                # Incluir paquetes específicos.
[325aac9]329                DEPENDENCIES=( ${DEPENDENCIES[@]} btrfs-progs )
[5cc52295]330                # Sustituir MySQL por MariaDB a partir de Fedora 20.
331                [ $OSVERSION -ge 20 ] && DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
[c79a2b3]332                ;;
[83518d5]333esac
334}
335
[d168a46]336
337#####################################################################
[a01156a]338####### Algunas funciones útiles de propósito general:
339#####################################################################
[d168a46]340
[13a01a7]341function getDateTime()
[a01156a]342{
[d168a46]343        date "+%Y%m%d-%H%M%S"
[a01156a]344}
345
346# Escribe a fichero y muestra por pantalla
[13a01a7]347function echoAndLog()
[a01156a]348{
[d168a46]349        local DATETIME=`getDateTime`
[87c7b02]350        echo "$1"
[d168a46]351        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
[a01156a]352}
353
[87c7b02]354# Escribe a fichero y muestra mensaje de error
[13a01a7]355function errorAndLog()
[a01156a]356{
[d168a46]357        local DATETIME=`getDateTime`
[87c7b02]358        echo "ERROR: $1"
[d168a46]359        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
[a01156a]360}
361
[346eaee]362# Escribe a fichero y muestra mensaje de aviso
363function warningAndLog()
364{
365        local DATETIME=`getDateTime`
[cd86637]366        echo "Warning: $1"
[346eaee]367        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
368}
369
[87c7b02]370# Comprueba si el elemento pasado en $2 está en el array $1
[13a01a7]371function isInArray()
[a01156a]372{
373        if [ $# -ne 2 ]; then
[13a01a7]374                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]375                exit 1
376        fi
377
378        local deps
[87c7b02]379        local is_in_array=1
380        local element="$2"
381
382        echoAndLog "${FUNCNAME}(): checking if $2 is in $1"
[5c33840]383        eval "deps=( \"\${$1[@]}\" )"
[a01156a]384
[87c7b02]385        # Copia local del array del parámetro 1.
386        for (( i = 0 ; i < ${#deps[@]} ; i++ )); do
387                if [ "${deps[$i]}" = "${element}" ]; then
388                        echoAndLog "isInArray(): $element found in array"
[a01156a]389                        is_in_array=0
390                fi
391        done
392
393        if [ $is_in_array -ne 0 ]; then
[87c7b02]394                echoAndLog "${FUNCNAME}(): $element NOT found in array"
[a01156a]395        fi
396
397        return $is_in_array
398}
399
[87c7b02]400
[a01156a]401#####################################################################
402####### Funciones de manejo de paquetes Debian
403#####################################################################
404
[13a01a7]405function checkPackage()
[a01156a]406{
407        package=$1
408        if [ -z $package ]; then
[73cfa0a]409                errorAndLog "${FUNCNAME}(): parameter required"
[a01156a]410                exit 1
411        fi
[73cfa0a]412        echoAndLog "${FUNCNAME}(): checking if package $package exists"
[d168a46]413        eval $CHECKPKG
[a01156a]414        if [ $? -eq 0 ]; then
[73cfa0a]415                echoAndLog "${FUNCNAME}(): package $package exists"
[a01156a]416                return 0
417        else
[73cfa0a]418                echoAndLog "${FUNCNAME}(): package $package doesn't exists"
[a01156a]419                return 1
420        fi
421}
422
[87c7b02]423# Recibe array con dependencias
[a01156a]424# por referencia deja un array con las dependencias no resueltas
425# devuelve 1 si hay alguna dependencia no resuelta
[13a01a7]426function checkDependencies()
[a01156a]427{
428        if [ $# -ne 2 ]; then
[73cfa0a]429                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]430                exit 1
431        fi
432
[73cfa0a]433        echoAndLog "${FUNCNAME}(): checking dependences"
[a01156a]434        uncompletedeps=0
435
436        # copia local del array del parametro 1
437        local deps
[5c33840]438        eval "deps=( \"\${$1[@]}\" )"
[a01156a]439
440        declare -a local_notinstalled
[5c33840]441
[a01156a]442        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
443        do
444                checkPackage ${deps[$i]}
445                if [ $? -ne 0 ]; then
446                        local_notinstalled[$uncompletedeps]=$package
447                        let uncompletedeps=uncompletedeps+1
448                fi
449        done
450
451        # relleno el array especificado en $2 por referencia
452        for (( i = 0 ; i < ${#local_notinstalled[@]} ; i++ ))
453        do
454                eval "${2}[$i]=${local_notinstalled[$i]}"
455        done
456
457        # retorna el numero de paquetes no resueltos
[73cfa0a]458        echoAndLog "${FUNCNAME}(): dependencies uncompleted: $uncompletedeps"
[a01156a]459        return $uncompletedeps
460}
461
462# Recibe un array con las dependencias y lo instala
[13a01a7]463function installDependencies()
[a01156a]464{
465        if [ $# -ne 1 ]; then
[813f617]466                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]467                exit 1
468        fi
[813f617]469        echoAndLog "${FUNCNAME}(): installing uncompleted dependencies"
[a01156a]470
471        # copia local del array del parametro 1
472        local deps
[5c33840]473        eval "deps=( \"\${$1[@]}\" )"
[a01156a]474
475        local string_deps=""
476        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
477        do
478                string_deps="$string_deps ${deps[$i]}"
479        done
480
481        if [ -z "${string_deps}" ]; then
[813f617]482                errorAndLog "${FUNCNAME}(): array of dependeces is empty"
[a01156a]483                exit 1
484        fi
485
[c79a2b3]486        OLD_DEBIAN_FRONTEND=$DEBIAN_FRONTEND            # Debian/Ubuntu
[a01156a]487        export DEBIAN_FRONTEND=noninteractive
488
[d168a46]489        echoAndLog "${FUNCNAME}(): now $string_deps will be installed"
490        eval $INSTALLPKG $string_deps
[a01156a]491        if [ $? -ne 0 ]; then
[813f617]492                errorAndLog "${FUNCNAME}(): error installing dependencies"
[a01156a]493                return 1
494        fi
495
[c79a2b3]496        DEBIAN_FRONTEND=$OLD_DEBIAN_FRONTEND            # Debian/Ubuntu
[6019b12]497        test grep -q "EPEL temporal" /etc/yum.repos.d/epel.repo 2>/dev/null || mv -f /etc/yum.repos.d/epel.repo.rpmnew /etc/yum.repos.d/epel.repo 2>/dev/null   # CentOS/RedHat EPEL
[c79a2b3]498
[813f617]499        echoAndLog "${FUNCNAME}(): dependencies installed"
[a01156a]500}
501
[13a01a7]502# Hace un backup del fichero pasado por parámetro
503# deja un -last y uno para el día
504function backupFile()
505{
506        if [ $# -ne 1 ]; then
507                errorAndLog "${FUNCNAME}(): invalid number of parameters"
508                exit 1
509        fi
510
[d168a46]511        local file="$1"
512        local dateymd=`date +%Y%m%d`
[13a01a7]513
[d168a46]514        if [ ! -f "$file" ]; then
[346eaee]515                warningAndLog "${FUNCNAME}(): file $file doesn't exists"
[13a01a7]516                return 1
517        fi
518
[d168a46]519        echoAndLog "${FUNCNAME}(): making $file backup"
[13a01a7]520
521        # realiza una copia de la última configuración como last
[d168a46]522        cp -a "$file" "${file}-LAST"
[13a01a7]523
524        # si para el día no hay backup lo hace, sino no
[d168a46]525        if [ ! -f "${file}-${dateymd}" ]; then
526                cp -a "$file" "${file}-${dateymd}"
[13a01a7]527        fi
528
[d168a46]529        echoAndLog "${FUNCNAME}(): $file backup success"
[13a01a7]530}
531
[a01156a]532#####################################################################
533####### Funciones para el manejo de bases de datos
534#####################################################################
535
536# This function set password to root
[13a01a7]537function mysqlSetRootPassword()
[a01156a]538{
539        if [ $# -ne 1 ]; then
[813f617]540                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]541                exit 1
542        fi
543
[e0edc14]544        local root_mysql="$1"
[813f617]545        echoAndLog "${FUNCNAME}(): setting root password in MySQL server"
[e0edc14]546        mysqladmin -u root password "$root_mysql"
[a01156a]547        if [ $? -ne 0 ]; then
[813f617]548                errorAndLog "${FUNCNAME}(): error while setting root password in MySQL server"
[a01156a]549                return 1
550        fi
[813f617]551        echoAndLog "${FUNCNAME}(): root password saved!"
[a01156a]552        return 0
553}
554
[892606b9]555# Si el servicio mysql esta ya instalado cambia la variable de la clave del root por la ya existente
[e0edc14]556function mysqlGetRootPassword()
557{
[892606b9]558        local pass_mysql
559        local pass_mysql2
[7c54b49]560        # Comprobar si MySQL está instalado con la clave de root por defecto.
561        if mysql -u root -p"$MYSQL_ROOT_PASSWORD" <<<"quit" 2>/dev/null; then
562                echoAndLog "${FUNCNAME}(): Using default mysql root password."
563        else
564                stty -echo
[e0edc14]565                echo "There is a MySQL service already installed."
566                read -p "Enter MySQL root password: " pass_mysql
[7c54b49]567                echo ""
[e0edc14]568                read -p "Confrim password:" pass_mysql2
[7c54b49]569                echo ""
570                stty echo
571                if [ "$pass_mysql" == "$pass_mysql2" ] ;then
[e0edc14]572                        MYSQL_ROOT_PASSWORD="$pass_mysql"
[7c54b49]573                        return 0
574                else
[e0edc14]575                        echo "The keys don't match. Do not configure the server's key,"
576                        echo "transactions in the database will give error."
[7c54b49]577                        return 1
578                fi
[892606b9]579        fi
580}
581
[a01156a]582# comprueba si puede conectar con mysql con el usuario root
583function mysqlTestConnection()
584{
585        if [ $# -ne 1 ]; then
[e0edc14]586                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]587                exit 1
588        fi
589
[09bf701]590        local root_password="$1"
[e0edc14]591        echoAndLog "${FUNCNAME}(): checking connection to mysql..."
[09bf701]592        # Componer fichero con credenciales de conexión a MySQL.
593        touch $TMPMYCNF
594        chmod 600 $TMPMYCNF
595        cat << EOT > $TMPMYCNF
[c073224]596[client]
[09bf701]597user=root
598password=$root_password
599EOT
600        # Borrar el fichero temporal si termina el proceso de instalación.
601        trap "rm -f $TMPMYCNF" 0 1 2 3 6 9 15
602        # Comprobar conexión a MySQL.
603        echo "" | mysql --defaults-extra-file=$TMPMYCNF
[a01156a]604        if [ $? -ne 0 ]; then
[e0edc14]605                errorAndLog "${FUNCNAME}(): connection to mysql failed, check root password and if daemon is running!"
[a01156a]606                return 1
607        else
[e0edc14]608                echoAndLog "${FUNCNAME}(): connection success"
[a01156a]609                return 0
610        fi
611}
612
613# comprueba si la base de datos existe
614function mysqlDbExists()
615{
[09bf701]616        if [ $# -ne 1 ]; then
[e0edc14]617                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]618                exit 1
619        fi
620
[09bf701]621        local database="$1"
[e0edc14]622        echoAndLog "${FUNCNAME}(): checking if $database exists..."
[09bf701]623        echo "show databases" | mysql --defaults-extra-file=$TMPMYCNF | grep "^${database}$"
[a01156a]624        if [ $? -ne 0 ]; then
[e0edc14]625                echoAndLog "${FUNCNAME}():database $database doesn't exists"
[a01156a]626                return 1
627        else
[e0edc14]628                echoAndLog "${FUNCNAME}():database $database exists"
[a01156a]629                return 0
630        fi
631}
632
[0a735488]633# Comprueba si la base de datos está vacía.
[a01156a]634function mysqlCheckDbIsEmpty()
635{
[09bf701]636        if [ $# -ne 1 ]; then
[e0edc14]637                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]638                exit 1
639        fi
640
[09bf701]641        local database="$1"
[e0edc14]642        echoAndLog "${FUNCNAME}(): checking if $database is empty..."
[09bf701]643        num_tablas=`echo "show tables" | mysql --defaults-extra-file=$TMPMYCNF "${database}" | wc -l`
[a01156a]644        if [ $? -ne 0 ]; then
[e0edc14]645                errorAndLog "${FUNCNAME}(): error executing query, check database and root password"
[a01156a]646                exit 1
647        fi
648
649        if [ $num_tablas -eq 0 ]; then
[e0edc14]650                echoAndLog "${FUNCNAME}():database $database is empty"
[a01156a]651                return 0
652        else
[e0edc14]653                echoAndLog "${FUNCNAME}():database $database has tables"
[a01156a]654                return 1
655        fi
656
657}
658
[0a735488]659# Importa un fichero SQL en la base de datos.
660# Parámetros:
661# - 1: nombre de la BD.
662# - 2: fichero a importar.
663# Nota: el fichero SQL puede contener las siguientes palabras reservadas:
664# - SERVERIP: se sustituye por la dirección IP del servidor.
665# - DBUSER: se sustituye por usuario de conexión a la BD definido en este script.
666# - DBPASSWD: se sustituye por la clave de conexión a la BD definida en este script.
[a01156a]667function mysqlImportSqlFileToDb()
668{
[09bf701]669        if [ $# -ne 2 ]; then
[c5ce04c]670                errorAndLog "${FNCNAME}(): invalid number of parameters"
[a01156a]671                exit 1
672        fi
673
[09bf701]674        local database="$1"
675        local sqlfile="$2"
[c4321ae]676        local tmpfile=$(mktemp)
[d168a46]677        local i=0
678        local dev=""
[c4321ae]679        local status
[8e0f770]680        # Claves aleatorias para acceso a las APIs REST.
[7829e4e]681        local OPENGNSYS_APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
[f9b5714]682        OPENGNSYS_REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
[a01156a]683
684        if [ ! -f $sqlfile ]; then
[c5ce04c]685                errorAndLog "${FUNCNAME}(): Unable to locate $sqlfile!!"
[a01156a]686                return 1
687        fi
688
[d168a46]689        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
[c4321ae]690        chmod 600 $tmpfile
[d168a46]691        for dev in ${DEVICE[*]}; do
[73a1bd6]692                if [ "${DEVICE[i]}" == "$DEFAULTDEV" ]; then
[d168a46]693                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
694                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
695                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
[7829e4e]696                            -e "s/APIKEY/$OPENGNSYS_APIKEY/g" \
[8e0f770]697                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[d168a46]698                                $sqlfile > $tmpfile
699                fi
700                let i++
701        done
[09bf701]702        mysql --defaults-extra-file=$TMPMYCNF --default-character-set=utf8 "${database}" < $tmpfile
[c4321ae]703        status=$?
704        rm -f $tmpfile
705        if [ $status -ne 0 ]; then
[c5ce04c]706                errorAndLog "${FUNCNAME}(): error while importing $sqlfile in database $database"
[a01156a]707                return 1
708        fi
[c5ce04c]709        echoAndLog "${FUNCNAME}(): file imported to database $database"
[a01156a]710        return 0
711}
712
713# Crea la base de datos
714function mysqlCreateDb()
715{
[09bf701]716        if [ $# -ne 1 ]; then
[a555f49]717                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]718                exit 1
719        fi
720
[09bf701]721        local database="$1"
[a01156a]722
[a555f49]723        echoAndLog "${FUNCNAME}(): creating database..."
[09bf701]724        mysqladmin --defaults-extra-file=$TMPMYCNF create $database
[a01156a]725        if [ $? -ne 0 ]; then
[a555f49]726                errorAndLog "${FUNCNAME}(): error while creating database $database"
[a01156a]727                return 1
728        fi
[e47e131]729        # Quitar modo ONLY_FULL_GROUP_BY de MySQL (ticket #730).
730        mysql --defaults-extra-file=$TMPMYCNF -e "SET GLOBAL sql_mode=(SELECT TRIM(BOTH ',' FROM REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')));"
731
[a555f49]732        echoAndLog "${FUNCNAME}(): database $database created"
[a01156a]733        return 0
734}
735
[0a735488]736# Comprueba si ya está definido el usuario de acceso a la BD.
[a01156a]737function mysqlCheckUserExists()
738{
[09bf701]739        if [ $# -ne 1 ]; then
[e0edc14]740                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]741                exit 1
742        fi
743
[09bf701]744        local userdb="$1"
[a01156a]745
[e0edc14]746        echoAndLog "${FUNCNAME}(): checking if $userdb exists..."
[09bf701]747        echo "select user from user where user='${userdb}'\\G" |mysql --defaults-extra-file=$TMPMYCNF mysql | grep user
[a01156a]748        if [ $? -ne 0 ]; then
[e0edc14]749                echoAndLog "${FUNCNAME}(): user doesn't exists"
[a01156a]750                return 1
751        else
[e0edc14]752                echoAndLog "${FUNCNAME}(): user already exists"
[a01156a]753                return 0
754        fi
755
756}
757
758# Crea un usuario administrativo para la base de datos
759function mysqlCreateAdminUserToDb()
760{
[09bf701]761        if [ $# -ne 3 ]; then
[e0edc14]762                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]763                exit 1
764        fi
765
[09bf701]766        local database="$1"
767        local userdb="$2"
768        local passdb="$3"
[a01156a]769
[e0edc14]770        echoAndLog "${FUNCNAME}(): creating admin user ${userdb} to database ${database}"
[a01156a]771
772        cat > $WORKDIR/create_${database}.sql <<EOF
773GRANT USAGE ON *.* TO '${userdb}'@'localhost' IDENTIFIED BY '${passdb}' ;
774GRANT ALL PRIVILEGES ON ${database}.* TO '${userdb}'@'localhost' WITH GRANT OPTION ;
775FLUSH PRIVILEGES ;
776EOF
[09bf701]777        mysql --defaults-extra-file=$TMPMYCNF < $WORKDIR/create_${database}.sql
[a01156a]778        if [ $? -ne 0 ]; then
[e0edc14]779                errorAndLog "${FUNCNAME}(): error while creating user in mysql"
[a01156a]780                rm -f $WORKDIR/create_${database}.sql
781                return 1
782        else
[e0edc14]783                echoAndLog "${FUNCNAME}(): user created ok"
[a01156a]784                rm -f $WORKDIR/create_${database}.sql
785                return 0
786        fi
787}
788
789
790#####################################################################
791####### Funciones para el manejo de Subversion
792#####################################################################
793
[0a735488]794# Obtiene el código fuente del proyecto desde el servidor SVN.
[13a01a7]795function svnExportCode()
796{
797        if [ $# -ne 1 ]; then
798                errorAndLog "${FUNCNAME}(): invalid number of parameters"
799                exit 1
800        fi
801
[6090a2d]802        local url="$1"
[13a01a7]803
804        echoAndLog "${FUNCNAME}(): downloading subversion code..."
805
[6090a2d]806        svn export --force "$url" opengnsys
[13a01a7]807        if [ $? -ne 0 ]; then
[5f21d34]808                errorAndLog "${FUNCNAME}(): error getting OpenGnsys code from $url"
[13a01a7]809                return 1
810        fi
811        echoAndLog "${FUNCNAME}(): subversion code downloaded"
812        return 0
813}
814
815
[892606b9]816############################################################
[7586ca3]817###  Detectar red
818############################################################
819
[07c3a59]820# Comprobar si existe conexión.
821function checkNetworkConnection()
822{
[09ac3b8]823        echoAndLog "${FUNCNAME}(): Disabling Firewall: $FIREWALLSERV."
824        if [ -n "$FIREWALLSERV" ]; then
825                service=$FIREWALLSERV
[b83843c]826                $STOPSERVICE; $DISABLESERVICE
827        fi
[109e8b2]828
[5f21d34]829        echoAndLog "${FUNCNAME}(): Checking OpenGnsys server conectivity."
[a0081b7]830        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"opengnsys.es"}
[225e859]831        if which wget &>/dev/null; then
832                wget --spider -q $OPENGNSYS_SERVER
833        elif which curl &>/dev/null; then
834                curl --connect-timeout 10 -s $OPENGNSYS_SERVER -o /dev/null
835        else
836                echoAndLog "${FUNCNAME}(): Cannot execute \"wget\" nor \"curl\"."
837                return 1
838        fi
[07c3a59]839}
840
[140fbd5]841# Convierte nº de bits (notación CIDR) en máscara de red (gracias a FriedZombie en openwrt.org).
842cidr2mask ()
843{
844        # Number of args to shift, 255..255, first non-255 byte, zeroes
845        set -- $[ 5 - ($1 / 8) ] 255 255 255 255 $[ (255 << (8 - ($1 % 8))) & 255 ] 0 0 0
846        [ $1 -gt 1 ] && shift $1 || shift
847        echo ${1-0}.${2-0}.${3-0}.${4-0}
848}
849
[07c3a59]850# Obtener los parámetros de red de la interfaz por defecto.
[7586ca3]851function getNetworkSettings()
852{
[d168a46]853        # Arrays globales definidas:
854        # - DEVICE:     nombres de dispositivos de red activos.
855        # - SERVERIP:   IPs locales del servidor.
856        # - NETIP:      IPs de redes.
857        # - NETMASK:    máscaras de red.
858        # - NETBROAD:   IPs de difusión de redes.
859        # - ROUTERIP:   IPs de routers.
860        # Otras variables globales:
861        # - DEFAULTDEV: dispositivo de red por defecto.
862        # - DNSIP:      IP del servidor DNS principal.
863
864        local i=0
865        local dev=""
866
[109e8b2]867        echoAndLog "${FUNCNAME}(): Detecting network parameters."
[d168a46]868        DEVICE=( $(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}') )
869        if [ -z "$DEVICE" ]; then
870                errorAndLog "${FUNCNAME}(): Network devices not detected."
[62e3bcf]871                exit 1
872        fi
[d168a46]873        for dev in ${DEVICE[*]}; do
[140fbd5]874                SERVERIP[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
[d168a46]875                if [ -n "${SERVERIP[i]}" ]; then
[140fbd5]876                        NETMASK[i]=$( cidr2mask $(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/.*\//, "", $4); print ($4)}') )
877                        NETBROAD[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {print ($6)}')
[826d576]878                        NETIP[i]=$(ip route | awk -v d="$dev" '$3==d && /src/ {sub (/\/.*/,""); print $1}')
879                        ROUTERIP[i]=$(ip route | awk -v d="$dev" '$1=="default" && $5==d {print $3}')
[d168a46]880                        DEFAULTDEV=${DEFAULTDEV:-"$dev"}
881                fi
[ce85ae8]882                let i++
[d168a46]883        done
[a555f49]884        DNSIP=$(awk '/nameserver/ {print $2}' /etc/resolv.conf | head -n1)
[03cfd6e]885        if [ -z "${NETIP[*]}" -o -z "${NETMASK[*]}" ]; then
[62e3bcf]886                errorAndLog "${FUNCNAME}(): Network not detected."
[7586ca3]887                exit 1
888        fi
[cc7eab7]889
890        # Variables de ejecución de Apache
891        # - APACHE_RUN_USER
892        # - APACHE_RUN_GROUP
[d168a46]893        if [ -f $APACHECFGDIR/envvars ]; then
894                source $APACHECFGDIR/envvars
[cc7eab7]895        fi
[d168a46]896        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
897        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
[73a1bd6]898
899        echoAndLog "${FUNCNAME}(): Default network device: $DEFAULTDEV."
[7586ca3]900}
901
902
903############################################################
[892606b9]904### Esqueleto para el Servicio pxe y contenedor tftpboot ###
905############################################################
906
[e0edc14]907function tftpConfigure()
908{
[109e8b2]909        echoAndLog "${FUNCNAME}(): Configuring TFTP service."
910        # Habilitar TFTP y reiniciar Inetd.
[8244351]911        if [ -n "$TFTPSERV" ]; then
[584b103]912                if [ -f $INETDCFGDIR/$TFTPSERV ]; then
913                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/$TFTPSERV
914                else
915                        service=$TFTPSERV
[b8969db]916                        $ENABLESERVICE; $STARTSERVICE
[584b103]917                fi
[8244351]918        fi
[53fba30]919        service=$INETDSERV
920        $ENABLESERVICE; $STARTSERVICE
[892606b9]921
[297df16]922        # comprobamos el servicio tftp
923        sleep 1
924        testPxe
[892606b9]925}
926
[0a735488]927# Comprueba que haya conexión al servicio TFTP/PXE.
[e0edc14]928function testPxe ()
929{
[297df16]930        echoAndLog "${FUNCNAME}(): Checking TFTP service... please wait."
[beaebf8]931        echo "test" >$TFTPCFGDIR/testpxe
932        tftp -v 127.0.0.1 -c get testpxe /tmp/testpxe && echoAndLog "TFTP service is OK." || errorAndLog "TFTP service is down."
933        rm -f $TFTPCFGDIR/testpxe /tmp/testpxe
[e4b1572]934}
935
936
937########################################################################
[5f21d34]938## Configuración servicio Samba
[8fc9552]939########################################################################
[e4b1572]940
941# Configurar servicios Samba.
[8fc9552]942function smbConfigure()
943{
[e0edc14]944        echoAndLog "${FUNCNAME}(): Configuring Samba service."
[8fc9552]945
[d168a46]946        backupFile $SAMBACFGDIR/smb.conf
[8fc9552]947       
[5f21d34]948        # Copiar plantailla de recursos para OpenGnsys
[c1e00e4]949        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
[d168a46]950                $WORKDIR/opengnsys/server/etc/smb-og.conf.tmpl > $SAMBACFGDIR/smb-og.conf
[813f617]951        # Configurar y recargar Samba"
[5f21d34]952        perl -pi -e "s/WORKGROUP/OPENGNSYS/; s/server string \=.*/server string \= OpenGnsys Samba Server/" $SAMBACFGDIR/smb.conf
[03cfd6e]953        if ! grep -q "smb-og" $SAMBACFGDIR/smb.conf; then
954                echo "include = $SAMBACFGDIR/smb-og.conf" >> $SAMBACFGDIR/smb.conf
955        fi
[53fba30]956        service=$SAMBASERV
957        $ENABLESERVICE; $STARTSERVICE
[8fc9552]958        if [ $? -ne 0 ]; then
[813f617]959                errorAndLog "${FUNCNAME}(): error while configure Samba"
[8fc9552]960                return 1
961        fi
[eb9424f]962        # Crear clave para usuario de acceso a los recursos.
[813f617]963        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | smbpasswd -a -s $OPENGNSYS_CLIENT_USER
[8fc9552]964
[813f617]965        echoAndLog "${FUNCNAME}(): Added Samba configuration."
[8fc9552]966        return 0
967}
968
969
[b6906f7]970########################################################################
[5f21d34]971## Configuración servicio Rsync
[e70925a]972########################################################################
973
974# Configurar servicio Rsync.
975function rsyncConfigure()
976{
977        echoAndLog "${FUNCNAME}(): Configuring Rsync service."
978
979        backupFile $RSYNCCFGDIR/rsyncd.conf
980
981        # Configurar acceso a Rsync.
982        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
983                $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > $RSYNCCFGDIR/rsyncd.conf
984        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
985            -e "s/CLIENTPASSWORD/$OPENGNSYS_CLIENT_PASSWD/g" \
986                $WORKDIR/opengnsys/repoman/etc/rsyncd.secrets.tmpl > $RSYNCCFGDIR/rsyncd.secrets
987        chown root.root $RSYNCCFGDIR/rsyncd.secrets
988        chmod 600 $RSYNCCFGDIR/rsyncd.secrets
989
990        # Habilitar Rsync y reiniciar Inetd.
991        if [ -n "$RSYNCSERV" ]; then
[4666588]992                if [ -f /etc/default/rsync ]; then
993                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
994                fi
[f243a47]995                if [ -f $INETDCFGDIR/rsync ]; then
996                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
997                else
998                        cat << EOT > $INETDCFGDIR/rsync
999service rsync
1000{
1001        disable = no
1002        socket_type = stream
1003        wait = no
1004        user = root
1005        server = $(which rsync)
1006        server_args = --daemon
1007        log_on_failure += USERID
1008        flags = IPv6
1009}
1010EOT
1011                fi
[e70925a]1012                service=$RSYNCSERV $ENABLESERVICE
1013                service=$INETDSERV $STARTSERVICE
1014        fi
1015
1016        echoAndLog "${FUNCNAME}(): Added Rsync configuration."
1017        return 0
1018}
1019
1020       
1021########################################################################
[5f21d34]1022## Configuración servicio DHCP
[b6906f7]1023########################################################################
1024
[e4b1572]1025# Configurar servicios DHCP.
[7586ca3]1026function dhcpConfigure()
1027{
[836a7597]1028        echoAndLog "${FUNCNAME}(): Sample DHCP configuration."
[a555f49]1029
[d168a46]1030        local errcode=0
1031        local i=0
1032        local dev=""
1033
1034        backupFile $DHCPCFGDIR/dhcpd.conf
1035        for dev in ${DEVICE[*]}; do
[01a9904]1036                if [ -n "${SERVERIP[i]}" ]; then
[d168a46]1037                        backupFile $DHCPCFGDIR/dhcpd-$dev.conf
[e4b1572]1038                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1039                            -e "s/NETIP/${NETIP[i]}/g" \
1040                            -e "s/NETMASK/${NETMASK[i]}/g" \
1041                            -e "s/NETBROAD/${NETBROAD[i]}/g" \
1042                            -e "s/ROUTERIP/${ROUTERIP[i]}/g" \
[d168a46]1043                            -e "s/DNSIP/$DNSIP/g" \
1044                            $WORKDIR/opengnsys/server/etc/dhcpd.conf.tmpl > $DHCPCFGDIR/dhcpd-$dev.conf || errcode=1
1045                fi
1046                let i++
1047        done
1048        if [ $errcode -ne 0 ]; then
[b25fc47]1049                errorAndLog "${FUNCNAME}(): error while configuring DHCP server"
[a555f49]1050                return 1
1051        fi
[d168a46]1052        ln -f $DHCPCFGDIR/dhcpd-$DEFAULTDEV.conf $DHCPCFGDIR/dhcpd.conf
[53fba30]1053        service=$DHCPSERV
1054        $ENABLESERVICE; $STARTSERVICE
[d168a46]1055        echoAndLog "${FUNCNAME}(): Sample DHCP configured in \"$DHCPCFGDIR\"."
[a555f49]1056        return 0
[892606b9]1057}
1058
1059
[a01156a]1060#####################################################################
1061####### Funciones específicas de la instalación de Opengnsys
1062#####################################################################
1063
[5f21d34]1064# Copiar ficheros del OpenGnsys Web Console.
[7586ca3]1065function installWebFiles()
1066{
[2b793a8]1067        local COMPATDIR f
[7829e4e]1068        local SLIMFILE="slim-2.6.1.zip"
[8b8e948]1069        local SWAGGERFILE="swagger-ui-2.2.5.zip"
[2b793a8]1070
[dce072b]1071        echoAndLog "${FUNCNAME}(): Installing web files..."
[2b793a8]1072        # Copiar ficheros.
1073        cp -a $WORKDIR/opengnsys/admin/WebConsole/* $INSTALL_TARGET/www   #*/ comentario para Doxygen.
[7586ca3]1074        if [ $? != 0 ]; then
[dce072b]1075                errorAndLog "${FUNCNAME}(): Error copying web files."
[7586ca3]1076                exit 1
1077        fi
1078        find $INSTALL_TARGET/www -name .svn -type d -exec rm -fr {} \; 2>/dev/null
[7829e4e]1079
[1635f45]1080        # Descomprimir librerías: Slim y Swagger-UI.
[7829e4e]1081        unzip -o $WORKDIR/opengnsys/admin/$SLIMFILE -d $INSTALL_TARGET/www/rest
[8b8e948]1082        unzip -o $WORKDIR/opengnsys/admin/$SWAGGERFILE -d $INSTALL_TARGET/www/rest
[7829e4e]1083
[2b793a8]1084        # Compatibilidad con dispositivos móviles.
1085        COMPATDIR="$INSTALL_TARGET/www/principal"
1086        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
1087                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
1088        done
1089        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
[7586ca3]1090        # Cambiar permisos para ficheros especiales.
[e6d22c6]1091        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/images/{fotos,iconos}
[b7bd0df]1092        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/tmp/
[0645906]1093        # Ficheros de log de la API REST.
1094        touch $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
1095        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
[2b793a8]1096
[dce072b]1097        echoAndLog "${FUNCNAME}(): Web files installed successfully."
[7586ca3]1098}
1099
[ec045b1]1100# Copiar ficheros en la zona de descargas de OpenGnsys Web Console.
1101function installDownloadableFiles()
1102{
1103        local FILENAME=ogagentpkgs-$INSTVERSION.tar.gz
1104        local TARGETFILE=$WORKDIR/$FILENAME
1105 
1106        # Descargar archivo comprimido, si es necesario.
1107        if [ -s $PROGRAMDIR/$FILENAME ]; then
1108                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1109                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1110        else
1111                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
[d5cbfa8]1112                curl $DOWNLOADURL/$FILENAME -o $TARGETFILE
[ec045b1]1113        fi
1114        if [ ! -s $TARGETFILE ]; then
1115                errorAndLog "${FUNCNAME}(): Cannot download $FILENAME"
1116                return 1
1117        fi
1118       
1119        # Descomprimir fichero en zona de descargas.
1120        tar xvzf $TARGETFILE -C $INSTALL_TARGET/www/descargas
1121        if [ $? != 0 ]; then
1122                errorAndLog "${FUNCNAME}(): Error uncompressing archive."
1123                exit 1
1124        fi
1125}
1126
[7586ca3]1127# Configuración específica de Apache.
[73a1bd6]1128function installWebConsoleApacheConf()
[a01156a]1129{
1130        if [ $# -ne 2 ]; then
[dce072b]1131                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]1132                exit 1
1133        fi
1134
[f9e3393]1135        local path_opengnsys_base="$1"
1136        local path_apache2_confd="$2"
[30837bb]1137        local CONSOLEDIR=${path_opengnsys_base}/www
[a01156a]1138
[892606b9]1139        if [ ! -d $path_apache2_confd ]; then
[dce072b]1140                errorAndLog "${FUNCNAME}(): path to apache2 conf.d can not found, verify your server installation"
[892606b9]1141                return 1
1142        fi
1143
[7586ca3]1144        mkdir -p $path_apache2_confd/{sites-available,sites-enabled}
[892606b9]1145
[dce072b]1146        echoAndLog "${FUNCNAME}(): creating apache2 config file.."
[a01156a]1147
[3ce53a7]1148        # Activar HTTPS.
[7825e9e]1149        $APACHESSLMOD
[643ca8c]1150        $APACHEENABLESSL
1151        $APACHEMAKECERT
[7829e4e]1152        # Activar módulo Rewrite.
1153        $APACHEREWRITEMOD
[30837bb]1154        # Genera configuración de consola web a partir del fichero plantilla.
[f9e3393]1155        if [ -n "$(apachectl -v | grep "2\.[0-2]")" ]; then
1156                # Configuración para versiones anteriores de Apache.
[6f4d39b]1157                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
[f3dde7e]1158                        $WORKDIR/opengnsys/server/etc/apache-prev2.4.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}
[f9e3393]1159        else
1160                # Configuración específica a partir de Apache 2.4
[6f4d39b]1161                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
[f3dde7e]1162                        $WORKDIR/opengnsys/server/etc/apache.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}.conf
[f9e3393]1163        fi
[643ca8c]1164        $APACHEENABLEOG
[a01156a]1165        if [ $? -ne 0 ]; then
[dce072b]1166                errorAndLog "${FUNCNAME}(): config file can't be linked to apache conf, verify your server installation"
[a01156a]1167                return 1
1168        fi
[103bc82]1169        echoAndLog "${FUNCNAME}(): config file created and linked, restarting apache daemon"
1170        service=$APACHESERV
1171        $ENABLESERVICE; $STARTSERVICE
1172        return 0
[a01156a]1173}
1174
[8fc9552]1175
[5d6bf97]1176# Crear documentación Doxygen para la consola web.
1177function makeDoxygenFiles()
1178{
1179        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
1180        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
1181                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
1182        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
1183                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
[ead38fb]1184                return 1
[5d6bf97]1185        fi
1186        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
1187        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
1188        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
1189}
1190
1191
[a01156a]1192# Crea la estructura base de la instalación de opengnsys
[eb9424f]1193function createDirs()
[a01156a]1194{
1195        if [ $# -ne 1 ]; then
[dce072b]1196                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]1197                exit 1
1198        fi
1199
[eb9424f]1200        local path_opengnsys_base="$1"
[a01156a]1201
[eb9424f]1202        # Crear estructura de directorios.
[dce072b]1203        echoAndLog "${FUNCNAME}(): creating directory paths in $path_opengnsys_base"
[a01156a]1204        mkdir -p $path_opengnsys_base
1205        mkdir -p $path_opengnsys_base/bin
[5c33840]1206        mkdir -p $path_opengnsys_base/client
[49c6891]1207        mkdir -p $path_opengnsys_base/doc
[5c33840]1208        mkdir -p $path_opengnsys_base/etc
[a01156a]1209        mkdir -p $path_opengnsys_base/lib
[1cc5697]1210        mkdir -p $path_opengnsys_base/log/clients
[eb9424f]1211        ln -fs $path_opengnsys_base/log /var/log/opengnsys
[7586ca3]1212        mkdir -p $path_opengnsys_base/sbin
[a01156a]1213        mkdir -p $path_opengnsys_base/www
[d7ece95]1214        mkdir -p $path_opengnsys_base/images/groups
[87c7b02]1215        mkdir -p $TFTPCFGDIR
[63fd1ba]1216        ln -fs $TFTPCFGDIR $path_opengnsys_base/tftpboot
[cfad47b]1217        mkdir -p $path_opengnsys_base/tftpboot/menu.lst
[a01156a]1218        if [ $? -ne 0 ]; then
[dce072b]1219                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
[a01156a]1220                return 1
1221        fi
1222
[eb9424f]1223        # Crear usuario ficticio.
1224        if id -u $OPENGNSYS_CLIENT_USER &>/dev/null; then
1225                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENT_USER\" is already created"
1226        else
[5f21d34]1227                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
[eb9424f]1228                useradd $OPENGNSYS_CLIENT_USER 2>/dev/null
1229                if [ $? -ne 0 ]; then
[5f21d34]1230                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
[eb9424f]1231                        return 1
1232                fi
1233        fi
1234
1235        # Establecer los permisos básicos.
1236        echoAndLog "${FUNCNAME}(): setting directory permissions"
[5eb61a6]1237        chmod -R 775 $path_opengnsys_base/{log/clients,images}
1238        chown -R :$OPENGNSYS_CLIENT_USER $path_opengnsys_base/{log/clients,images}
[eb9424f]1239        if [ $? -ne 0 ]; then
1240                errorAndLog "${FUNCNAME}(): error while setting permissions"
1241                return 1
1242        fi
1243
[7669bca]1244        # Mover el fichero de registro de instalación al directorio de logs.
[acfb07d]1245        echoAndLog "${FUNCNAME}(): moving installation log file"
1246        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
[7669bca]1247        chmod 600 $LOG_FILE
[acfb07d]1248
[dce072b]1249        echoAndLog "${FUNCNAME}(): directory paths created"
[a01156a]1250        return 0
1251}
1252
[463a1d49]1253# Copia ficheros de configuración y ejecutables genéricos del servidor.
[73a1bd6]1254function copyServerFiles ()
[e0edc14]1255{
[463a1d49]1256        if [ $# -ne 1 ]; then
[879689f]1257                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[463a1d49]1258                exit 1
1259        fi
1260
[7caf5a7c]1261        local path_opengnsys_base="$1"
[463a1d49]1262
[a43e90d]1263        # Lista de ficheros y directorios origen y de directorios destino.
[cfad47b]1264        local SOURCES=( server/tftpboot \
[7caf5a7c]1265                        server/bin \
1266                        repoman/bin \
[3e7d77b]1267                        server/lib \
[42a0e41]1268                        admin/Sources/Services/ogAdmServerAux
1269                        admin/Sources/Services/ogAdmRepoAux
[7caf5a7c]1270                        installer/opengnsys_uninstall.sh \
1271                        installer/opengnsys_update.sh \
[6777e3e]1272                        installer/opengnsys_export.sh \
1273                        installer/opengnsys_import.sh \
[7caf5a7c]1274                        doc )
[cfad47b]1275        local TARGETS=( tftpboot \
[7caf5a7c]1276                        bin \
1277                        bin \
[3e7d77b]1278                        lib \
[42a0e41]1279                        sbin \
1280                        sbin \
[7caf5a7c]1281                        lib \
1282                        lib \
[6777e3e]1283                        lib \
1284                        lib \
[7caf5a7c]1285                        doc )
[463a1d49]1286
1287        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
[879689f]1288                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
[463a1d49]1289                exit 1
1290        fi
1291
[a43e90d]1292        # Copiar ficheros.
[879689f]1293        echoAndLog "${FUNCNAME}(): copying files to server directories"
[f2bb433]1294
[8457092]1295        pushd $WORKDIR/opengnsys
[463a1d49]1296        local i
1297        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
1298                if [ -f "${SOURCES[$i]}" ]; then
[879689f]1299                        echoAndLog "Copying ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[b5aae72]1300                        cp -a "${SOURCES[$i]}" "${path_opengnsys_base}/${TARGETS[$i]}"
[8457092]1301                elif [ -d "${SOURCES[$i]}" ]; then
[879689f]1302                        echoAndLog "Copying content of ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[8457092]1303                        cp -a "${SOURCES[$i]}"/* "${path_opengnsys_base}/${TARGETS[$i]}"
1304        else
[346eaee]1305                        warningAndLog "Unable to copy ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[463a1d49]1306                fi
1307        done
[a43e90d]1308
[7586ca3]1309        popd
[892606b9]1310}
1311
[7586ca3]1312####################################################################
[5eb61a6]1313### Funciones de compilación de código fuente de servicios
[7586ca3]1314####################################################################
1315
[5f21d34]1316# Compilar los servicios de OpenGnsys
[7586ca3]1317function servicesCompilation ()
1318{
[13a01a7]1319        local hayErrores=0
[0795938]1320
[5f21d34]1321        # Compilar OpenGnsys Server
1322        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Server"
[7b61735]1323        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
[d168a46]1324        make && mv ogAdmServer $INSTALL_TARGET/sbin
[13a01a7]1325        if [ $? -ne 0 ]; then
[5f21d34]1326                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
[13a01a7]1327                hayErrores=1
1328        fi
[7586ca3]1329        popd
[5f21d34]1330        # Compilar OpenGnsys Repository Manager
1331        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Repository Manager"
[7b61735]1332        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
[d168a46]1333        make && mv ogAdmRepo $INSTALL_TARGET/sbin
[13a01a7]1334        if [ $? -ne 0 ]; then
[5f21d34]1335                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Repository Manager"
[13a01a7]1336                hayErrores=1
1337        fi
[8125e7c]1338        popd
[5f21d34]1339        # Compilar OpenGnsys Agent
1340        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Agent"
[7b61735]1341        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
[d168a46]1342        make && mv ogAdmAgent $INSTALL_TARGET/sbin
[4984660]1343        if [ $? -ne 0 ]; then
[5f21d34]1344                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
[4984660]1345                hayErrores=1
1346        fi
1347        popd   
[5f21d34]1348        # Compilar OpenGnsys Client
1349        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Client"
[7b61735]1350        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
[2338c95f]1351        make && mv ogAdmClient ../../../../client/shared/bin
[13a01a7]1352        if [ $? -ne 0 ]; then
[5f21d34]1353                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Client"
[13a01a7]1354                hayErrores=1
1355        fi
[318efac]1356        popd
[13a01a7]1357
1358        return $hayErrores
[b6906f7]1359}
1360
[7b61735]1361####################################################################
1362### Funciones de copia de la Interface de administración
1363####################################################################
1364
1365# Copiar carpeta de Interface
[c1e00e4]1366function copyInterfaceAdm ()
[7b61735]1367{
1368        local hayErrores=0
1369       
[fbd9bcc]1370        # Crear carpeta y copiar Interface
[7b61735]1371        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
[fbd9bcc]1372        cp -ar $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client/interfaceAdm
[7b61735]1373        if [ $? -ne 0 ]; then
1374                echoAndLog "${FUNCNAME}(): error while copying Administration Interface Folder"
1375                hayErrores=1
1376        fi
[b6f1726]1377        chown $OPENGNSYS_CLIENT_USER:$OPENGNSYS_CLIENT_USER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[f6c1d2b]1378        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
[7b61735]1379
1380        return $hayErrores
1381}
[b6906f7]1382
[892606b9]1383####################################################################
1384### Funciones instalacion cliente opengnsys
1385####################################################################
1386
[73a1bd6]1387function copyClientFiles()
[7586ca3]1388{
[d168a46]1389        local errstatus=0
[a555f49]1390
[5f21d34]1391        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Client files."
[73a1bd6]1392        cp -a $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
[d47d38d]1393        if [ $? -ne 0 ]; then
[9ef8920]1394                errorAndLog "${FUNCNAME}(): error while copying client estructure"
[d168a46]1395                errstatus=1
[9ef8920]1396        fi
[d47d38d]1397        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
[9ef8920]1398       
[5f21d34]1399        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Cloning Engine files."
[d47d38d]1400        mkdir -p $INSTALL_TARGET/client/lib/engine/bin
[73a1bd6]1401        cp -a $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
[a555f49]1402        if [ $? -ne 0 ]; then
1403                errorAndLog "${FUNCNAME}(): error while copying engine files"
[d168a46]1404                errstatus=1
[a555f49]1405        fi
[9ef8920]1406       
[d168a46]1407        if [ $errstatus -eq 0 ]; then
[9ef8920]1408                echoAndLog "${FUNCNAME}(): client copy files success."
1409        else
1410                errorAndLog "${FUNCNAME}(): client copy files with errors"
1411        fi
1412
[d168a46]1413        return $errstatus
[463a1d49]1414}
1415
1416
[5f21d34]1417# Crear cliente OpenGnsys.
[5ad5dcc]1418function clientCreate()
[813f617]1419{
[6019b12]1420        if [ $# -ne 1 ]; then
1421                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1422                exit 1
1423        fi
1424
1425        local FILENAME="$1"
[0b85cc93]1426        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
[d168a46]1427 
[79c26a8]1428        # Descargar cliente, si es necesario.
1429        if [ -s $PROGRAMDIR/$FILENAME ]; then
1430                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1431                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1432        else
[ec045b1]1433                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
[6019b12]1434                oglivecli download $FILENAME
[79c26a8]1435        fi
[0b85cc93]1436        if [ ! -s $TARGETFILE ]; then
[ec045b1]1437                errorAndLog "${FUNCNAME}(): Error loading $FILENAME"
[813f617]1438                return 1
1439        fi
[1893b9d]1440
[79c26a8]1441        # Montar imagen, copiar cliente ogclient y desmontar.
[0496417]1442        echoAndLog "${FUNCNAME}(): Installing ogLive Client"
[6ef01d9]1443        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | \
[6019b12]1444                        oglivecli install $FILENAME
[1893b9d]1445        # Adaptar permisos.
[beaebf8]1446        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/tftpboot/menu.lst
[6ef01d9]1447
[813f617]1448        echoAndLog "${FUNCNAME}(): Client generation success"
1449}
1450
1451
[5f21d34]1452# Configuración básica de servicios de OpenGnsys
[cc7eab7]1453function openGnsysConfigure()
1454{
[d168a46]1455        local i=0
1456        local dev=""
[7d4ce64]1457        local CONSOLEURL
[d168a46]1458
[9ee62ad]1459        echoAndLog "${FUNCNAME}(): Copying init files."
[42a0e41]1460        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
1461        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default /etc/default/opengnsys
[b8969db]1462        # Deshabilitar servicios de BitTorrent si no están instalados.
1463        if [ ! -e /usr/bin/bttrack ]; then
[fdab5d0]1464                sed -i 's/RUN_BTTRACKER="yes"/RUN_BTTRACKER="no"/; s/RUN_BTSEEDER="yes"/RUN_BTSEEDER="no"/' \
[b8969db]1465                        /etc/default/opengnsys
1466        fi
[9ee62ad]1467        echoAndLog "${FUNCNAME}(): Creating cron files."
[57cf15b]1468        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
[9ee62ad]1469        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
[8fc9552]1470        echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
[dc762088]1471        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
[0645906]1472        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/ogagentqueue.cron ] && $INSTALL_TARGET/bin/ogagentqueue.cron" > /etc/cron.d/ogagentqueue
[d168a46]1473
[700299b]1474        echoAndLog "${FUNCNAME}(): Creating logrotate configuration file."
1475        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
1476                $WORKDIR/opengnsys/server/etc/logrotate.tmpl > /etc/logrotate.d/opengnsys
1477
[5f21d34]1478        echoAndLog "${FUNCNAME}(): Creating OpenGnsys config files."
[d168a46]1479        for dev in ${DEVICE[*]}; do
1480                if [ -n "${SERVERIP[i]}" ]; then
1481                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1482                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1483                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1484                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1485                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer/ogAdmServer.cfg > $INSTALL_TARGET/etc/ogAdmServer-$dev.cfg
1486                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
[f9b5714]1487                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[d168a46]1488                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo/ogAdmRepo.cfg > $INSTALL_TARGET/etc/ogAdmRepo-$dev.cfg
1489                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1490                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1491                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1492                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1493                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent/ogAdmAgent.cfg > $INSTALL_TARGET/etc/ogAdmAgent-$dev.cfg
[1a2fa9d8]1494                        CONSOLEURL="https://${SERVERIP[i]}/opengnsys"
[d168a46]1495                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1496                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1497                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1498                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
[b22305e]1499                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
[d168a46]1500                                $INSTALL_TARGET/www/controlacceso.php > $INSTALL_TARGET/www/controlacceso-$dev.php
1501                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
[d7f8305]1502                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
[d168a46]1503                                $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient/ogAdmClient.cfg > $INSTALL_TARGET/client/etc/ogAdmClient-$dev.cfg
[7d4ce64]1504                        if [ "$dev" == "$DEFAULTDEV" ]; then
[1a2fa9d8]1505                                OPENGNSYS_CONSOLEURL="$CONSOLEURL"
[7d4ce64]1506                        fi
[d168a46]1507                fi
1508                let i++
1509        done
1510        ln -f $INSTALL_TARGET/etc/ogAdmServer-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmServer.cfg
1511        ln -f $INSTALL_TARGET/etc/ogAdmRepo-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmRepo.cfg
1512        ln -f $INSTALL_TARGET/etc/ogAdmAgent-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmAgent.cfg
1513        ln -f $INSTALL_TARGET/client/etc/ogAdmClient-$DEFAULTDEV.cfg $INSTALL_TARGET/client/etc/ogAdmClient.cfg
1514        ln -f $INSTALL_TARGET/www/controlacceso-$DEFAULTDEV.php $INSTALL_TARGET/www/controlacceso.php
1515        chown root:root $INSTALL_TARGET/etc/{ogAdmServer,ogAdmAgent}*.cfg
1516        chmod 600 $INSTALL_TARGET/etc/{ogAdmServer,ogAdmAgent}*.cfg
1517        chown $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/controlacceso*.php
1518        chmod 600 $INSTALL_TARGET/www/controlacceso*.php
[1f7b2d0]1519
[a3855dc]1520        # Configuración del motor de clonación.
1521        # - Zona horaria del servidor.
1522        TZ=$(timedatectl status|awk -F"[:()]" '/Time.*zone/ {print $2}')
1523        cat << EOT >> $INSTALL_TARGET/client/etc/engine.cfg
1524# OpenGnsys Server timezone.
1525TZ="${TZ// /}"
1526EOT
1527
[1f7b2d0]1528        # Revisar permisos generales.
1529        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
1530                echoAndLog "${FUNCNAME}(): Checking permissions."
[6019b12]1531                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENT_USER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" checkperms
[1f7b2d0]1532        fi
1533
[4e19f13]1534        # Evitar inicio de duplicado en Ubuntu 14.04 (Upstart y SysV Init).
[c7ade22]1535        if [ -f /etc/init/${MYSQLSERV}.conf -a -n "$(which initctl 2>/dev/null)" ]; then
[4e19f13]1536                service=$MYSQLSERV
1537                $DISABLESERVICE
1538        fi
1539
[5f21d34]1540        echoAndLog "${FUNCNAME}(): Starting OpenGnsys services."
[53fba30]1541        service="opengnsys"
1542        $ENABLESERVICE; $STARTSERVICE
[cc7eab7]1543}
1544
[b6906f7]1545
[a01156a]1546#####################################################################
[180a07dd]1547#######  Función de resumen informativo de la instalación
1548#####################################################################
1549
[813f617]1550function installationSummary()
1551{
[eb9424f]1552        # Crear fichero de versión y revisión, si no existe.
1553        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
[5f21d34]1554        [ -f $VERSIONFILE ] || echo "OpenGnsys Server" >$VERSIONFILE
[130bdbf]1555        # Incluir datos de revisión, si se está instaladno desde el repositorio
1556        # de código o si no está incluida en el fichero de versión.
1557        if [ $USESVN -eq 1 ] || [ -z "$(awk '$3~/r[0-9]*/ {print}' $VERSIONFILE)" ]; then
1558                local REVISION=$(LANG=C svn info $SVN_URL|awk '/Rev:/ {print "r"$4}')
1559                perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
1560        fi
[eb9424f]1561
1562        # Mostrar información.
[180a07dd]1563        echo
[5f21d34]1564        echoAndLog "OpenGnsys Installation Summary"
[180a07dd]1565        echo       "=============================="
[eb9424f]1566        echoAndLog "Project version:                  $(cat $VERSIONFILE 2>/dev/null)"
[49c6891]1567        echoAndLog "Installation directory:           $INSTALL_TARGET"
[acfb07d]1568        echoAndLog "Installation log file:            $LOG_FILE"
[49c6891]1569        echoAndLog "Repository directory:             $INSTALL_TARGET/images"
[d168a46]1570        echoAndLog "DHCP configuration directory:     $DHCPCFGDIR"
[87c7b02]1571        echoAndLog "TFTP configuration directory:     $TFTPCFGDIR"
[6019b12]1572        echoAndLog "Installed ogLive client(s):       $(oglivecli list | awk '{print $2}')"
[87c7b02]1573        echoAndLog "Samba configuration directory:    $SAMBACFGDIR"
[49c6891]1574        echoAndLog "Web Console URL:                  $OPENGNSYS_CONSOLEURL"
[35b0ef1]1575        echoAndLog "Web Console access data:          specified in installer script"
[b8969db]1576        if grep -q "^RUN_BTTRACK.*no" /etc/default/opengnsys; then
1577                echoAndLog "BitTorrent service is disabled."
1578        fi
[180a07dd]1579        echo
1580        echoAndLog "Post-Installation Instructions:"
1581        echo       "==============================="
[663c6625]1582        echoAndLog "Firewall service has been disabled and SELinux mode set to"
[5f21d34]1583        echoAndLog "   permissive during OpenGnsys installation. Please check"
[64f4ada]1584        echoAndLog "   ${FIREWALLSERV:-firewall} and SELinux configuration, if needed."
[4faafcd]1585        echoAndLog "It's strongly recommended to synchronize this server with an NTP server."
[180a07dd]1586        echoAndLog "Review or edit all configuration files."
[c5ce04c]1587        echoAndLog "Insert DHCP configuration data and restart service."
[af5efd6]1588        echoAndLog "Optional: Log-in as Web Console admin user."
1589        echoAndLog " - Review default Organization data and assign access to users."
[180a07dd]1590        echoAndLog "Log-in as Web Console organization user."
[5f21d34]1591        echoAndLog " - Insert OpenGnsys data (labs, computers, menus, etc)."
[180a07dd]1592echo
1593}
1594
1595
1596
1597#####################################################################
[5f21d34]1598####### Proceso de instalación de OpenGnsys
[a01156a]1599#####################################################################
1600
[5f21d34]1601echoAndLog "OpenGnsys installation begins at $(date)"
[6090a2d]1602pushd $WORKDIR
[cc7eab7]1603
[af5efd6]1604# Detectar datos iniciales de auto-configuración del instalador.
[d168a46]1605autoConfigure
1606
1607# Detectar parámetros de red y comprobar si hay conexión.
1608getNetworkSettings
1609if [ $? -ne 0 ]; then
1610        errorAndLog "Error reading default network settings."
1611        exit 1
1612fi
[07c3a59]1613checkNetworkConnection
1614if [ $? -ne 0 ]; then
1615        errorAndLog "Error connecting to server. Causes:"
1616        errorAndLog " - Network is unreachable, review devices parameters."
1617        errorAndLog " - You are inside a private network, configure the proxy service."
1618        errorAndLog " - Server is temporally down, try agian later."
1619        exit 1
1620fi
[7586ca3]1621
[5f21d34]1622# Detener servicios de OpenGnsys, si están activos previamente.
[e0edc14]1623[ -f /etc/init.d/opengnsys ] && /etc/init.d/opengnsys stop
1624
[318efac]1625# Actualizar repositorios
[83518d5]1626updatePackageList
[318efac]1627
[b6906f7]1628# Instalación de dependencias (paquetes de sistema operativo).
[a01156a]1629declare -a notinstalled
1630checkDependencies DEPENDENCIES notinstalled
1631if [ $? -ne 0 ]; then
1632        installDependencies notinstalled
1633        if [ $? -ne 0 ]; then
1634                echoAndLog "Error while installing some dependeces, please verify your server installation before continue"
1635                exit 1
1636        fi
1637fi
[109e8b2]1638if [ -n "$INSTALLEXTRADEPS" ]; then
1639        echoAndLog "Installing extra dependencies"
1640        for (( i=0; i<${#INSTALLEXTRADEPS[*]}; i++ )); do
1641                eval ${INSTALLEXTRADEPS[i]}
1642        done
1643fi     
[a01156a]1644
[ff6c349]1645# Detectar datos de auto-configuración después de instalar paquetes.
1646autoConfigurePost
1647
[5f21d34]1648# Arbol de directorios de OpenGnsys.
[eb9424f]1649createDirs ${INSTALL_TARGET}
[a01156a]1650if [ $? -ne 0 ]; then
1651        errorAndLog "Error while creating directory paths!"
1652        exit 1
1653fi
[b6906f7]1654
[1e7eaab]1655# Si es necesario, descarga el repositorio de código en directorio temporal
[49c6891]1656if [ $USESVN -eq 1 ]; then
[1e7eaab]1657        svnExportCode $SVN_URL
1658        if [ $? -ne 0 ]; then
1659                errorAndLog "Error while getting code from svn"
1660                exit 1
1661        fi
1662else
1663        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
[a01156a]1664fi
1665
[5f21d34]1666# Compilar código fuente de los servicios de OpenGnsys.
[b6906f7]1667servicesCompilation
[13a01a7]1668if [ $? -ne 0 ]; then
1669        errorAndLog "Error while compiling OpenGnsys services"
1670        exit 1
1671fi
[b6906f7]1672
[7b61735]1673# Copiar carpeta Interface entre administración y motor de clonación.
[c1e00e4]1674copyInterfaceAdm
[7b61735]1675if [ $? -ne 0 ]; then
[c1e00e4]1676        errorAndLog "Error while copying Administration Interface"
[7b61735]1677        exit 1
1678fi
1679
[e70925a]1680# Configuración de TFTP.
[318efac]1681tftpConfigure
[b6906f7]1682
[e70925a]1683# Configuración de Samba.
[8fc9552]1684smbConfigure
1685if [ $? -ne 0 ]; then
[c1e00e4]1686        errorAndLog "Error while configuring Samba server!"
[8fc9552]1687        exit 1
1688fi
1689
[e70925a]1690# Configuración de Rsync.
1691rsyncConfigure
1692
1693# Configuración ejemplo DHCP.
[b6906f7]1694dhcpConfigure
[a555f49]1695if [ $? -ne 0 ]; then
1696        errorAndLog "Error while copying your dhcp server files!"
1697        exit 1
1698fi
[b6906f7]1699
[5f21d34]1700# Copiar ficheros de servicios OpenGnsys Server.
[73a1bd6]1701copyServerFiles ${INSTALL_TARGET}
[463a1d49]1702if [ $? -ne 0 ]; then
1703        errorAndLog "Error while copying the server files!"
1704        exit 1
1705fi
[730bde5]1706INSTVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
[463a1d49]1707
[5f21d34]1708# Instalar base de datos de OpenGnsys Admin.
[5cc52295]1709isInArray notinstalled "mysql-server" || isInArray notinstalled "mariadb-server"
[b6906f7]1710if [ $? -eq 0 ]; then
[094ac0d]1711        # Habilitar gestor de base de datos (MySQL, si falla, MariaDB).
1712        service=$MYSQLSERV
1713        $ENABLESERVICE
1714        if [ $? != 0 ]; then
1715                service=$MARIADBSERV
1716                $ENABLESERVICE
1717        fi
1718        # Activar gestor de base de datos.
[0f8100d]1719        $STARTSERVICE
[094ac0d]1720        # Asignar clave del usuario "root".
[09bf701]1721        mysqlSetRootPassword "${MYSQL_ROOT_PASSWORD}"
[b6906f7]1722else
[094ac0d]1723        # Si ya está instalado el gestor de bases de datos, obtener clave de "root",
[b6906f7]1724        mysqlGetRootPassword
1725fi
[463a1d49]1726
[09bf701]1727mysqlTestConnection "${MYSQL_ROOT_PASSWORD}"
[a01156a]1728if [ $? -ne 0 ]; then
1729        errorAndLog "Error while connection to mysql"
1730        exit 1
1731fi
[09bf701]1732mysqlDbExists ${OPENGNSYS_DATABASE}
[a01156a]1733if [ $? -ne 0 ]; then
[cc7eab7]1734        echoAndLog "Creating Web Console database"
[09bf701]1735        mysqlCreateDb ${OPENGNSYS_DATABASE}
[a01156a]1736        if [ $? -ne 0 ]; then
[cc7eab7]1737                errorAndLog "Error while creating Web Console database"
[a01156a]1738                exit 1
1739        fi
1740else
[cc7eab7]1741        echoAndLog "Web Console database exists, ommiting creation"
[a01156a]1742fi
1743
[09bf701]1744mysqlCheckUserExists ${OPENGNSYS_DB_USER}
[a01156a]1745if [ $? -ne 0 ]; then
1746        echoAndLog "Creating user in database"
[09bf701]1747        mysqlCreateAdminUserToDb ${OPENGNSYS_DATABASE} ${OPENGNSYS_DB_USER} "${OPENGNSYS_DB_PASSWD}"
[a01156a]1748        if [ $? -ne 0 ]; then
[cc7eab7]1749                errorAndLog "Error while creating database user"
[a01156a]1750                exit 1
1751        fi
1752
1753fi
1754
[09bf701]1755mysqlCheckDbIsEmpty ${OPENGNSYS_DATABASE}
[a01156a]1756if [ $? -eq 0 ]; then
1757        echoAndLog "Creating tables..."
[892606b9]1758        if [ -f $WORKDIR/$OPENGNSYS_DB_CREATION_FILE ]; then
[09bf701]1759                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_CREATION_FILE
[a01156a]1760        else
[892606b9]1761                errorAndLog "Unable to locate $WORKDIR/$OPENGNSYS_DB_CREATION_FILE!!"
[a01156a]1762                exit 1
1763        fi
[bc7dfe7]1764else
1765        # Si existe fichero ogBDAdmin-VersLocal-VersRepo.sql; aplicar cambios.
1766        REPOVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
[295b4ab]1767        OPENGNSYS_DB_UPDATE_FILE="opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
1768        if [ -f $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE ]; then
[bc7dfe7]1769                echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
[09bf701]1770                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE
[bc7dfe7]1771        else
1772                echoAndLog "Database unchanged."
1773        fi
[a01156a]1774fi
[09bf701]1775# Eliminar fichero temporal con credenciales de acceso a MySQL.
1776rm -f $TMPMYCNF
[a01156a]1777
[5f21d34]1778# Copiando páqinas web.
[7586ca3]1779installWebFiles
[ec045b1]1780# Descargar/descomprimir archivos descargables.
1781installDownloadableFiles
[5d6bf97]1782# Generar páqinas web de documentación de la API
1783makeDoxygenFiles
[a01156a]1784
[5f21d34]1785# Creando configuración de Apache.
[5fcf180]1786installWebConsoleApacheConf $INSTALL_TARGET $APACHECFGDIR
[a01156a]1787if [ $? -ne 0 ]; then
[5f21d34]1788        errorAndLog "Error configuring Apache for OpenGnsys Admin"
[a01156a]1789        exit 1
1790fi
1791
1792popd
[892606b9]1793
[9ef8920]1794# Crear la estructura de los accesos al servidor desde el cliente (shared)
[73a1bd6]1795copyClientFiles
[9ef8920]1796if [ $? -ne 0 ]; then
1797        errorAndLog "Error creating client structure"
1798fi
1799
[5f21d34]1800# Crear la estructura del cliente de OpenGnsys.
[6019b12]1801for i in $OGLIVE; do
1802        if ! clientCreate "$i"; then
1803                errorAndLog "Error creating client $i"
1804                exit 1
1805        fi
1806done
[892606b9]1807
[5f21d34]1808# Configuración de servicios de OpenGnsys
[65245d1]1809openGnsysConfigure
1810
[180a07dd]1811# Mostrar sumario de la instalación e instrucciones de post-instalación.
1812installationSummary
1813
[077dd7c5]1814#rm -rf $WORKDIR
[5f21d34]1815echoAndLog "OpenGnsys installation finished at $(date)"
[05d2e03]1816exit 0
[2308fc7]1817
Note: See TracBrowser for help on using the repository browser.